/*eslint-disable block-scoped-var, no-redeclare, no-control-regex, no-prototype-builtins*/
"use strict";

var $protobuf = require("protobufjs/minimal");

// Common aliases
var $Reader = $protobuf.Reader, $Writer = $protobuf.Writer, $util = $protobuf.util;

// Exported root namespace
var $root = $protobuf.roots["default"] || ($protobuf.roots["default"] = {});

$root.proto = (function() {

    /**
     * Namespace proto.
     * @exports proto
     * @namespace
     */
    var proto = {};

    proto.DataLeakage = (function() {

        /**
         * Properties of a DataLeakage.
         * @memberof proto
         * @interface IDataLeakage
         * @property {Array.<proto.IDetection>} [detections] DataLeakage detections
         * @property {proto.IInvocation} [invocation] DataLeakage invocation
         */

        /**
         * Constructs a new DataLeakage.
         * @memberof proto
         * @classdesc Represents a DataLeakage.
         * @constructor
         * @param {proto.IDataLeakage=} [properties] Properties to set
         */
        function DataLeakage(properties) {
            this.detections = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * DataLeakage detections.
         * @member {Array.<proto.IDetection>}detections
         * @memberof proto.DataLeakage
         * @instance
         */
        DataLeakage.prototype.detections = $util.emptyArray;

        /**
         * DataLeakage invocation.
         * @member {(proto.IInvocation|null|undefined)}invocation
         * @memberof proto.DataLeakage
         * @instance
         */
        DataLeakage.prototype.invocation = null;

        /**
         * Creates a new DataLeakage instance using the specified properties.
         * @function create
         * @memberof proto.DataLeakage
         * @static
         * @param {proto.IDataLeakage=} [properties] Properties to set
         * @returns {proto.DataLeakage} DataLeakage instance
         */
        DataLeakage.create = function create(properties) {
            return new DataLeakage(properties);
        };

        /**
         * Encodes the specified DataLeakage message. Does not implicitly {@link proto.DataLeakage.verify|verify} messages.
         * @function encode
         * @memberof proto.DataLeakage
         * @static
         * @param {proto.IDataLeakage} message DataLeakage message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DataLeakage.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.detections != null && message.detections.length)
                for (var i = 0; i < message.detections.length; ++i)
                    $root.proto.Detection.encode(message.detections[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                $root.proto.Invocation.encode(message.invocation, writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified DataLeakage message, length delimited. Does not implicitly {@link proto.DataLeakage.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.DataLeakage
         * @static
         * @param {proto.IDataLeakage} message DataLeakage message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        DataLeakage.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a DataLeakage message from the specified reader or buffer.
         * @function decode
         * @memberof proto.DataLeakage
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.DataLeakage} DataLeakage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DataLeakage.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.DataLeakage();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.detections && message.detections.length))
                        message.detections = [];
                    message.detections.push($root.proto.Detection.decode(reader, reader.uint32()));
                    break;
                case 2:
                    message.invocation = $root.proto.Invocation.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a DataLeakage message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.DataLeakage
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.DataLeakage} DataLeakage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        DataLeakage.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a DataLeakage message.
         * @function verify
         * @memberof proto.DataLeakage
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        DataLeakage.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.detections != null && message.hasOwnProperty("detections")) {
                if (!Array.isArray(message.detections))
                    return "detections: array expected";
                for (var i = 0; i < message.detections.length; ++i) {
                    var error = $root.proto.Detection.verify(message.detections[i]);
                    if (error)
                        return "detections." + error;
                }
            }
            if (message.invocation != null && message.hasOwnProperty("invocation")) {
                error = $root.proto.Invocation.verify(message.invocation);
                if (error)
                    return "invocation." + error;
            }
            return null;
        };

        /**
         * Creates a DataLeakage message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.DataLeakage
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.DataLeakage} DataLeakage
         */
        DataLeakage.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.DataLeakage)
                return object;
            var message = new $root.proto.DataLeakage();
            if (object.detections) {
                if (!Array.isArray(object.detections))
                    throw TypeError(".proto.DataLeakage.detections: array expected");
                message.detections = [];
                for (var i = 0; i < object.detections.length; ++i) {
                    if (typeof object.detections[i] !== "object")
                        throw TypeError(".proto.DataLeakage.detections: object expected");
                    message.detections[i] = $root.proto.Detection.fromObject(object.detections[i]);
                }
            }
            if (object.invocation != null) {
                if (typeof object.invocation !== "object")
                    throw TypeError(".proto.DataLeakage.invocation: object expected");
                message.invocation = $root.proto.Invocation.fromObject(object.invocation);
            }
            return message;
        };

        /**
         * Creates a plain object from a DataLeakage message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.DataLeakage
         * @static
         * @param {proto.DataLeakage} message DataLeakage
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        DataLeakage.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults)
                object.detections = [];
            if (options.defaults)
                object.invocation = null;
            if (message.detections && message.detections.length) {
                object.detections = [];
                for (var j = 0; j < message.detections.length; ++j)
                    object.detections[j] = $root.proto.Detection.toObject(message.detections[j], options);
            }
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                object.invocation = $root.proto.Invocation.toObject(message.invocation, options);
            return object;
        };

        /**
         * Converts this DataLeakage to JSON.
         * @function toJSON
         * @memberof proto.DataLeakage
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        DataLeakage.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return DataLeakage;
    })();

    proto.Detection = (function() {

        /**
         * Properties of a Detection.
         * @memberof proto
         * @interface IDetection
         * @property {string} [ids] Detection ids
         * @property {string} [name] Detection name
         * @property {string} [description] Detection description
         * @property {Array.<string>} [type] Detection type
         * @property {number} [severity] Detection severity
         * @property {number} [certainty] Detection certainty
         * @property {boolean} [successful] Detection successful
         * @property {boolean} [relevant] Detection relevant
         * @property {proto.Detection.Reason} [reason] Detection reason
         * @property {proto.GeneratedBy} [generatedby] Detection generatedby
         * @property {boolean} [attack] Detection attack
         * @property {Array.<string>} [input] Detection input
         * @property {Array.<string>} [errors] Detection errors
         * @property {number|Long} [hash] Detection hash
         * @property {number|Long} [ruleHash] Detection ruleHash
         * @property {string} [onKey] Detection onKey
         * @property {string} [byInput] Detection byInput
         * @property {Array.<string>} [tags] Detection tags
         */

        /**
         * Constructs a new Detection.
         * @memberof proto
         * @classdesc Represents a Detection.
         * @constructor
         * @param {proto.IDetection=} [properties] Properties to set
         */
        function Detection(properties) {
            this.type = [];
            this.input = [];
            this.errors = [];
            this.tags = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Detection ids.
         * @member {string}ids
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.ids = "";

        /**
         * Detection name.
         * @member {string}name
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.name = "";

        /**
         * Detection description.
         * @member {string}description
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.description = "";

        /**
         * Detection type.
         * @member {Array.<string>}type
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.type = $util.emptyArray;

        /**
         * Detection severity.
         * @member {number}severity
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.severity = 0;

        /**
         * Detection certainty.
         * @member {number}certainty
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.certainty = 0;

        /**
         * Detection successful.
         * @member {boolean}successful
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.successful = false;

        /**
         * Detection relevant.
         * @member {boolean}relevant
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.relevant = false;

        /**
         * Detection reason.
         * @member {proto.Detection.Reason}reason
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.reason = 0;

        /**
         * Detection generatedby.
         * @member {proto.GeneratedBy}generatedby
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.generatedby = 0;

        /**
         * Detection attack.
         * @member {boolean}attack
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.attack = false;

        /**
         * Detection input.
         * @member {Array.<string>}input
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.input = $util.emptyArray;

        /**
         * Detection errors.
         * @member {Array.<string>}errors
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.errors = $util.emptyArray;

        /**
         * Detection hash.
         * @member {number|Long}hash
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.hash = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Detection ruleHash.
         * @member {number|Long}ruleHash
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.ruleHash = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Detection onKey.
         * @member {string}onKey
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.onKey = "";

        /**
         * Detection byInput.
         * @member {string}byInput
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.byInput = "";

        /**
         * Detection tags.
         * @member {Array.<string>}tags
         * @memberof proto.Detection
         * @instance
         */
        Detection.prototype.tags = $util.emptyArray;

        /**
         * Creates a new Detection instance using the specified properties.
         * @function create
         * @memberof proto.Detection
         * @static
         * @param {proto.IDetection=} [properties] Properties to set
         * @returns {proto.Detection} Detection instance
         */
        Detection.create = function create(properties) {
            return new Detection(properties);
        };

        /**
         * Encodes the specified Detection message. Does not implicitly {@link proto.Detection.verify|verify} messages.
         * @function encode
         * @memberof proto.Detection
         * @static
         * @param {proto.IDetection} message Detection message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Detection.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.ids != null && message.hasOwnProperty("ids"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.ids);
            if (message.name != null && message.hasOwnProperty("name"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.name);
            if (message.description != null && message.hasOwnProperty("description"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.description);
            if (message.type != null && message.type.length)
                for (var i = 0; i < message.type.length; ++i)
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.type[i]);
            if (message.severity != null && message.hasOwnProperty("severity"))
                writer.uint32(/* id 5, wireType 5 =*/45).float(message.severity);
            if (message.certainty != null && message.hasOwnProperty("certainty"))
                writer.uint32(/* id 6, wireType 5 =*/53).float(message.certainty);
            if (message.successful != null && message.hasOwnProperty("successful"))
                writer.uint32(/* id 7, wireType 0 =*/56).bool(message.successful);
            if (message.relevant != null && message.hasOwnProperty("relevant"))
                writer.uint32(/* id 8, wireType 0 =*/64).bool(message.relevant);
            if (message.reason != null && message.hasOwnProperty("reason"))
                writer.uint32(/* id 9, wireType 0 =*/72).int32(message.reason);
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                writer.uint32(/* id 10, wireType 0 =*/80).int32(message.generatedby);
            if (message.attack != null && message.hasOwnProperty("attack"))
                writer.uint32(/* id 11, wireType 0 =*/88).bool(message.attack);
            if (message.input != null && message.input.length)
                for (var i = 0; i < message.input.length; ++i)
                    writer.uint32(/* id 12, wireType 2 =*/98).string(message.input[i]);
            if (message.errors != null && message.errors.length)
                for (var i = 0; i < message.errors.length; ++i)
                    writer.uint32(/* id 13, wireType 2 =*/106).string(message.errors[i]);
            if (message.hash != null && message.hasOwnProperty("hash"))
                writer.uint32(/* id 14, wireType 0 =*/112).int64(message.hash);
            if (message.ruleHash != null && message.hasOwnProperty("ruleHash"))
                writer.uint32(/* id 15, wireType 0 =*/120).int64(message.ruleHash);
            if (message.onKey != null && message.hasOwnProperty("onKey"))
                writer.uint32(/* id 16, wireType 2 =*/130).string(message.onKey);
            if (message.byInput != null && message.hasOwnProperty("byInput"))
                writer.uint32(/* id 17, wireType 2 =*/138).string(message.byInput);
            if (message.tags != null && message.tags.length)
                for (var i = 0; i < message.tags.length; ++i)
                    writer.uint32(/* id 18, wireType 2 =*/146).string(message.tags[i]);
            return writer;
        };

        /**
         * Encodes the specified Detection message, length delimited. Does not implicitly {@link proto.Detection.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Detection
         * @static
         * @param {proto.IDetection} message Detection message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Detection.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Detection message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Detection
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Detection} Detection
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Detection.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Detection();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.ids = reader.string();
                    break;
                case 2:
                    message.name = reader.string();
                    break;
                case 3:
                    message.description = reader.string();
                    break;
                case 4:
                    if (!(message.type && message.type.length))
                        message.type = [];
                    message.type.push(reader.string());
                    break;
                case 5:
                    message.severity = reader.float();
                    break;
                case 6:
                    message.certainty = reader.float();
                    break;
                case 7:
                    message.successful = reader.bool();
                    break;
                case 8:
                    message.relevant = reader.bool();
                    break;
                case 9:
                    message.reason = reader.int32();
                    break;
                case 10:
                    message.generatedby = reader.int32();
                    break;
                case 11:
                    message.attack = reader.bool();
                    break;
                case 12:
                    if (!(message.input && message.input.length))
                        message.input = [];
                    message.input.push(reader.string());
                    break;
                case 13:
                    if (!(message.errors && message.errors.length))
                        message.errors = [];
                    message.errors.push(reader.string());
                    break;
                case 14:
                    message.hash = reader.int64();
                    break;
                case 15:
                    message.ruleHash = reader.int64();
                    break;
                case 16:
                    message.onKey = reader.string();
                    break;
                case 17:
                    message.byInput = reader.string();
                    break;
                case 18:
                    if (!(message.tags && message.tags.length))
                        message.tags = [];
                    message.tags.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Detection message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Detection
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Detection} Detection
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Detection.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Detection message.
         * @function verify
         * @memberof proto.Detection
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Detection.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.ids != null && message.hasOwnProperty("ids"))
                if (!$util.isString(message.ids))
                    return "ids: string expected";
            if (message.name != null && message.hasOwnProperty("name"))
                if (!$util.isString(message.name))
                    return "name: string expected";
            if (message.description != null && message.hasOwnProperty("description"))
                if (!$util.isString(message.description))
                    return "description: string expected";
            if (message.type != null && message.hasOwnProperty("type")) {
                if (!Array.isArray(message.type))
                    return "type: array expected";
                for (var i = 0; i < message.type.length; ++i)
                    if (!$util.isString(message.type[i]))
                        return "type: string[] expected";
            }
            if (message.severity != null && message.hasOwnProperty("severity"))
                if (typeof message.severity !== "number")
                    return "severity: number expected";
            if (message.certainty != null && message.hasOwnProperty("certainty"))
                if (typeof message.certainty !== "number")
                    return "certainty: number expected";
            if (message.successful != null && message.hasOwnProperty("successful"))
                if (typeof message.successful !== "boolean")
                    return "successful: boolean expected";
            if (message.relevant != null && message.hasOwnProperty("relevant"))
                if (typeof message.relevant !== "boolean")
                    return "relevant: boolean expected";
            if (message.reason != null && message.hasOwnProperty("reason"))
                switch (message.reason) {
                default:
                    return "reason: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                switch (message.generatedby) {
                default:
                    return "generatedby: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            if (message.attack != null && message.hasOwnProperty("attack"))
                if (typeof message.attack !== "boolean")
                    return "attack: boolean expected";
            if (message.input != null && message.hasOwnProperty("input")) {
                if (!Array.isArray(message.input))
                    return "input: array expected";
                for (var i = 0; i < message.input.length; ++i)
                    if (!$util.isString(message.input[i]))
                        return "input: string[] expected";
            }
            if (message.errors != null && message.hasOwnProperty("errors")) {
                if (!Array.isArray(message.errors))
                    return "errors: array expected";
                for (var i = 0; i < message.errors.length; ++i)
                    if (!$util.isString(message.errors[i]))
                        return "errors: string[] expected";
            }
            if (message.hash != null && message.hasOwnProperty("hash"))
                if (!$util.isInteger(message.hash) && !(message.hash && $util.isInteger(message.hash.low) && $util.isInteger(message.hash.high)))
                    return "hash: integer|Long expected";
            if (message.ruleHash != null && message.hasOwnProperty("ruleHash"))
                if (!$util.isInteger(message.ruleHash) && !(message.ruleHash && $util.isInteger(message.ruleHash.low) && $util.isInteger(message.ruleHash.high)))
                    return "ruleHash: integer|Long expected";
            if (message.onKey != null && message.hasOwnProperty("onKey"))
                if (!$util.isString(message.onKey))
                    return "onKey: string expected";
            if (message.byInput != null && message.hasOwnProperty("byInput"))
                if (!$util.isString(message.byInput))
                    return "byInput: string expected";
            if (message.tags != null && message.hasOwnProperty("tags")) {
                if (!Array.isArray(message.tags))
                    return "tags: array expected";
                for (var i = 0; i < message.tags.length; ++i)
                    if (!$util.isString(message.tags[i]))
                        return "tags: string[] expected";
            }
            return null;
        };

        /**
         * Creates a Detection message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Detection
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Detection} Detection
         */
        Detection.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Detection)
                return object;
            var message = new $root.proto.Detection();
            if (object.ids != null)
                message.ids = String(object.ids);
            if (object.name != null)
                message.name = String(object.name);
            if (object.description != null)
                message.description = String(object.description);
            if (object.type) {
                if (!Array.isArray(object.type))
                    throw TypeError(".proto.Detection.type: array expected");
                message.type = [];
                for (var i = 0; i < object.type.length; ++i)
                    message.type[i] = String(object.type[i]);
            }
            if (object.severity != null)
                message.severity = Number(object.severity);
            if (object.certainty != null)
                message.certainty = Number(object.certainty);
            if (object.successful != null)
                message.successful = Boolean(object.successful);
            if (object.relevant != null)
                message.relevant = Boolean(object.relevant);
            switch (object.reason) {
            case "KNOWN_ATTACK":
            case 0:
                message.reason = 0;
                break;
            case "BEHAVIOUR":
            case 1:
                message.reason = 1;
                break;
            case "KNOWN_TOOL":
            case 2:
                message.reason = 2;
                break;
            }
            switch (object.generatedby) {
            case "BITBRAIN":
            case 0:
                message.generatedby = 0;
                break;
            case "PLUGIN":
            case 1:
                message.generatedby = 1;
                break;
            case "MODSECURITY":
            case 2:
                message.generatedby = 2;
                break;
            }
            if (object.attack != null)
                message.attack = Boolean(object.attack);
            if (object.input) {
                if (!Array.isArray(object.input))
                    throw TypeError(".proto.Detection.input: array expected");
                message.input = [];
                for (var i = 0; i < object.input.length; ++i)
                    message.input[i] = String(object.input[i]);
            }
            if (object.errors) {
                if (!Array.isArray(object.errors))
                    throw TypeError(".proto.Detection.errors: array expected");
                message.errors = [];
                for (var i = 0; i < object.errors.length; ++i)
                    message.errors[i] = String(object.errors[i]);
            }
            if (object.hash != null)
                if ($util.Long)
                    (message.hash = $util.Long.fromValue(object.hash)).unsigned = false;
                else if (typeof object.hash === "string")
                    message.hash = parseInt(object.hash, 10);
                else if (typeof object.hash === "number")
                    message.hash = object.hash;
                else if (typeof object.hash === "object")
                    message.hash = new $util.LongBits(object.hash.low >>> 0, object.hash.high >>> 0).toNumber();
            if (object.ruleHash != null)
                if ($util.Long)
                    (message.ruleHash = $util.Long.fromValue(object.ruleHash)).unsigned = false;
                else if (typeof object.ruleHash === "string")
                    message.ruleHash = parseInt(object.ruleHash, 10);
                else if (typeof object.ruleHash === "number")
                    message.ruleHash = object.ruleHash;
                else if (typeof object.ruleHash === "object")
                    message.ruleHash = new $util.LongBits(object.ruleHash.low >>> 0, object.ruleHash.high >>> 0).toNumber();
            if (object.onKey != null)
                message.onKey = String(object.onKey);
            if (object.byInput != null)
                message.byInput = String(object.byInput);
            if (object.tags) {
                if (!Array.isArray(object.tags))
                    throw TypeError(".proto.Detection.tags: array expected");
                message.tags = [];
                for (var i = 0; i < object.tags.length; ++i)
                    message.tags[i] = String(object.tags[i]);
            }
            return message;
        };

        /**
         * Creates a plain object from a Detection message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Detection
         * @static
         * @param {proto.Detection} message Detection
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Detection.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults) {
                object.type = [];
                object.input = [];
                object.errors = [];
                object.tags = [];
            }
            if (options.defaults) {
                object.ids = "";
                object.name = "";
                object.description = "";
                object.severity = 0;
                object.certainty = 0;
                object.successful = false;
                object.relevant = false;
                object.reason = options.enums === String ? "KNOWN_ATTACK" : 0;
                object.generatedby = options.enums === String ? "BITBRAIN" : 0;
                object.attack = false;
                if ($util.Long) {
                    var long = new $util.Long(0, 0, false);
                    object.hash = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                } else
                    object.hash = options.longs === String ? "0" : 0;
                if ($util.Long) {
                    var long = new $util.Long(0, 0, false);
                    object.ruleHash = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                } else
                    object.ruleHash = options.longs === String ? "0" : 0;
                object.onKey = "";
                object.byInput = "";
            }
            if (message.ids != null && message.hasOwnProperty("ids"))
                object.ids = message.ids;
            if (message.name != null && message.hasOwnProperty("name"))
                object.name = message.name;
            if (message.description != null && message.hasOwnProperty("description"))
                object.description = message.description;
            if (message.type && message.type.length) {
                object.type = [];
                for (var j = 0; j < message.type.length; ++j)
                    object.type[j] = message.type[j];
            }
            if (message.severity != null && message.hasOwnProperty("severity"))
                object.severity = options.json && !isFinite(message.severity) ? String(message.severity) : message.severity;
            if (message.certainty != null && message.hasOwnProperty("certainty"))
                object.certainty = options.json && !isFinite(message.certainty) ? String(message.certainty) : message.certainty;
            if (message.successful != null && message.hasOwnProperty("successful"))
                object.successful = message.successful;
            if (message.relevant != null && message.hasOwnProperty("relevant"))
                object.relevant = message.relevant;
            if (message.reason != null && message.hasOwnProperty("reason"))
                object.reason = options.enums === String ? $root.proto.Detection.Reason[message.reason] : message.reason;
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                object.generatedby = options.enums === String ? $root.proto.GeneratedBy[message.generatedby] : message.generatedby;
            if (message.attack != null && message.hasOwnProperty("attack"))
                object.attack = message.attack;
            if (message.input && message.input.length) {
                object.input = [];
                for (var j = 0; j < message.input.length; ++j)
                    object.input[j] = message.input[j];
            }
            if (message.errors && message.errors.length) {
                object.errors = [];
                for (var j = 0; j < message.errors.length; ++j)
                    object.errors[j] = message.errors[j];
            }
            if (message.hash != null && message.hasOwnProperty("hash"))
                if (typeof message.hash === "number")
                    object.hash = options.longs === String ? String(message.hash) : message.hash;
                else
                    object.hash = options.longs === String ? $util.Long.prototype.toString.call(message.hash) : options.longs === Number ? new $util.LongBits(message.hash.low >>> 0, message.hash.high >>> 0).toNumber() : message.hash;
            if (message.ruleHash != null && message.hasOwnProperty("ruleHash"))
                if (typeof message.ruleHash === "number")
                    object.ruleHash = options.longs === String ? String(message.ruleHash) : message.ruleHash;
                else
                    object.ruleHash = options.longs === String ? $util.Long.prototype.toString.call(message.ruleHash) : options.longs === Number ? new $util.LongBits(message.ruleHash.low >>> 0, message.ruleHash.high >>> 0).toNumber() : message.ruleHash;
            if (message.onKey != null && message.hasOwnProperty("onKey"))
                object.onKey = message.onKey;
            if (message.byInput != null && message.hasOwnProperty("byInput"))
                object.byInput = message.byInput;
            if (message.tags && message.tags.length) {
                object.tags = [];
                for (var j = 0; j < message.tags.length; ++j)
                    object.tags[j] = message.tags[j];
            }
            return object;
        };

        /**
         * Converts this Detection to JSON.
         * @function toJSON
         * @memberof proto.Detection
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Detection.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        /**
         * Reason enum.
         * @enum {string}
         * @property {number} KNOWN_ATTACK=0 KNOWN_ATTACK value
         * @property {number} BEHAVIOUR=1 BEHAVIOUR value
         * @property {number} KNOWN_TOOL=2 KNOWN_TOOL value
         */
        Detection.Reason = (function() {
            var valuesById = {}, values = Object.create(valuesById);
            values[valuesById[0] = "KNOWN_ATTACK"] = 0;
            values[valuesById[1] = "BEHAVIOUR"] = 1;
            values[valuesById[2] = "KNOWN_TOOL"] = 2;
            return values;
        })();

        return Detection;
    })();

    /**
     * GeneratedBy enum.
     * @enum {string}
     * @property {number} BITBRAIN=0 BITBRAIN value
     * @property {number} PLUGIN=1 PLUGIN value
     * @property {number} MODSECURITY=2 MODSECURITY value
     */
    proto.GeneratedBy = (function() {
        var valuesById = {}, values = Object.create(valuesById);
        values[valuesById[0] = "BITBRAIN"] = 0;
        values[valuesById[1] = "PLUGIN"] = 1;
        values[valuesById[2] = "MODSECURITY"] = 2;
        return values;
    })();

    proto.Invocation = (function() {

        /**
         * Properties of an Invocation.
         * @memberof proto
         * @interface IInvocation
         * @property {Array.<proto.Invocation.ISQLInvocation>} [sqlInvocations] Invocation sqlInvocations
         */

        /**
         * Constructs a new Invocation.
         * @memberof proto
         * @classdesc Represents an Invocation.
         * @constructor
         * @param {proto.IInvocation=} [properties] Properties to set
         */
        function Invocation(properties) {
            this.sqlInvocations = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Invocation sqlInvocations.
         * @member {Array.<proto.Invocation.ISQLInvocation>}sqlInvocations
         * @memberof proto.Invocation
         * @instance
         */
        Invocation.prototype.sqlInvocations = $util.emptyArray;

        /**
         * Creates a new Invocation instance using the specified properties.
         * @function create
         * @memberof proto.Invocation
         * @static
         * @param {proto.IInvocation=} [properties] Properties to set
         * @returns {proto.Invocation} Invocation instance
         */
        Invocation.create = function create(properties) {
            return new Invocation(properties);
        };

        /**
         * Encodes the specified Invocation message. Does not implicitly {@link proto.Invocation.verify|verify} messages.
         * @function encode
         * @memberof proto.Invocation
         * @static
         * @param {proto.IInvocation} message Invocation message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Invocation.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.sqlInvocations != null && message.sqlInvocations.length)
                for (var i = 0; i < message.sqlInvocations.length; ++i)
                    $root.proto.Invocation.SQLInvocation.encode(message.sqlInvocations[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
            return writer;
        };

        /**
         * Encodes the specified Invocation message, length delimited. Does not implicitly {@link proto.Invocation.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Invocation
         * @static
         * @param {proto.IInvocation} message Invocation message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Invocation.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Invocation message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Invocation
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Invocation} Invocation
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Invocation.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Invocation();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.sqlInvocations && message.sqlInvocations.length))
                        message.sqlInvocations = [];
                    message.sqlInvocations.push($root.proto.Invocation.SQLInvocation.decode(reader, reader.uint32()));
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Invocation message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Invocation
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Invocation} Invocation
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Invocation.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Invocation message.
         * @function verify
         * @memberof proto.Invocation
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Invocation.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.sqlInvocations != null && message.hasOwnProperty("sqlInvocations")) {
                if (!Array.isArray(message.sqlInvocations))
                    return "sqlInvocations: array expected";
                for (var i = 0; i < message.sqlInvocations.length; ++i) {
                    var error = $root.proto.Invocation.SQLInvocation.verify(message.sqlInvocations[i]);
                    if (error)
                        return "sqlInvocations." + error;
                }
            }
            return null;
        };

        /**
         * Creates an Invocation message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Invocation
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Invocation} Invocation
         */
        Invocation.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Invocation)
                return object;
            var message = new $root.proto.Invocation();
            if (object.sqlInvocations) {
                if (!Array.isArray(object.sqlInvocations))
                    throw TypeError(".proto.Invocation.sqlInvocations: array expected");
                message.sqlInvocations = [];
                for (var i = 0; i < object.sqlInvocations.length; ++i) {
                    if (typeof object.sqlInvocations[i] !== "object")
                        throw TypeError(".proto.Invocation.sqlInvocations: object expected");
                    message.sqlInvocations[i] = $root.proto.Invocation.SQLInvocation.fromObject(object.sqlInvocations[i]);
                }
            }
            return message;
        };

        /**
         * Creates a plain object from an Invocation message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Invocation
         * @static
         * @param {proto.Invocation} message Invocation
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Invocation.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults)
                object.sqlInvocations = [];
            if (message.sqlInvocations && message.sqlInvocations.length) {
                object.sqlInvocations = [];
                for (var j = 0; j < message.sqlInvocations.length; ++j)
                    object.sqlInvocations[j] = $root.proto.Invocation.SQLInvocation.toObject(message.sqlInvocations[j], options);
            }
            return object;
        };

        /**
         * Converts this Invocation to JSON.
         * @function toJSON
         * @memberof proto.Invocation
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Invocation.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        Invocation.SQLInvocation = (function() {

            /**
             * Properties of a SQLInvocation.
             * @memberof proto.Invocation
             * @interface ISQLInvocation
             * @property {Array.<proto.Invocation.SQLInvocation.IQuery>} [queries] SQLInvocation queries
             * @property {Object.<string,string>} [endpoint] SQLInvocation endpoint
             * @property {string} [prepareStatement] SQLInvocation prepareStatement
             * @property {string} [prepareCall] SQLInvocation prepareCall
             */

            /**
             * Constructs a new SQLInvocation.
             * @memberof proto.Invocation
             * @classdesc Represents a SQLInvocation.
             * @constructor
             * @param {proto.Invocation.ISQLInvocation=} [properties] Properties to set
             */
            function SQLInvocation(properties) {
                this.queries = [];
                this.endpoint = {};
                if (properties)
                    for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                        if (properties[keys[i]] != null)
                            this[keys[i]] = properties[keys[i]];
            }

            /**
             * SQLInvocation queries.
             * @member {Array.<proto.Invocation.SQLInvocation.IQuery>}queries
             * @memberof proto.Invocation.SQLInvocation
             * @instance
             */
            SQLInvocation.prototype.queries = $util.emptyArray;

            /**
             * SQLInvocation endpoint.
             * @member {Object.<string,string>}endpoint
             * @memberof proto.Invocation.SQLInvocation
             * @instance
             */
            SQLInvocation.prototype.endpoint = $util.emptyObject;

            /**
             * SQLInvocation prepareStatement.
             * @member {string}prepareStatement
             * @memberof proto.Invocation.SQLInvocation
             * @instance
             */
            SQLInvocation.prototype.prepareStatement = "";

            /**
             * SQLInvocation prepareCall.
             * @member {string}prepareCall
             * @memberof proto.Invocation.SQLInvocation
             * @instance
             */
            SQLInvocation.prototype.prepareCall = "";

            /**
             * Creates a new SQLInvocation instance using the specified properties.
             * @function create
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {proto.Invocation.ISQLInvocation=} [properties] Properties to set
             * @returns {proto.Invocation.SQLInvocation} SQLInvocation instance
             */
            SQLInvocation.create = function create(properties) {
                return new SQLInvocation(properties);
            };

            /**
             * Encodes the specified SQLInvocation message. Does not implicitly {@link proto.Invocation.SQLInvocation.verify|verify} messages.
             * @function encode
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {proto.Invocation.ISQLInvocation} message SQLInvocation message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SQLInvocation.encode = function encode(message, writer) {
                if (!writer)
                    writer = $Writer.create();
                if (message.queries != null && message.queries.length)
                    for (var i = 0; i < message.queries.length; ++i)
                        $root.proto.Invocation.SQLInvocation.Query.encode(message.queries[i], writer.uint32(/* id 1, wireType 2 =*/10).fork()).ldelim();
                if (message.endpoint != null && message.hasOwnProperty("endpoint"))
                    for (var keys = Object.keys(message.endpoint), i = 0; i < keys.length; ++i)
                        writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.endpoint[keys[i]]).ldelim();
                if (message.prepareStatement != null && message.hasOwnProperty("prepareStatement"))
                    writer.uint32(/* id 3, wireType 2 =*/26).string(message.prepareStatement);
                if (message.prepareCall != null && message.hasOwnProperty("prepareCall"))
                    writer.uint32(/* id 4, wireType 2 =*/34).string(message.prepareCall);
                return writer;
            };

            /**
             * Encodes the specified SQLInvocation message, length delimited. Does not implicitly {@link proto.Invocation.SQLInvocation.verify|verify} messages.
             * @function encodeDelimited
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {proto.Invocation.ISQLInvocation} message SQLInvocation message or plain object to encode
             * @param {$protobuf.Writer} [writer] Writer to encode to
             * @returns {$protobuf.Writer} Writer
             */
            SQLInvocation.encodeDelimited = function encodeDelimited(message, writer) {
                return this.encode(message, writer).ldelim();
            };

            /**
             * Decodes a SQLInvocation message from the specified reader or buffer.
             * @function decode
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @param {number} [length] Message length if known beforehand
             * @returns {proto.Invocation.SQLInvocation} SQLInvocation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SQLInvocation.decode = function decode(reader, length) {
                if (!(reader instanceof $Reader))
                    reader = $Reader.create(reader);
                var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Invocation.SQLInvocation(), key;
                while (reader.pos < end) {
                    var tag = reader.uint32();
                    switch (tag >>> 3) {
                    case 1:
                        if (!(message.queries && message.queries.length))
                            message.queries = [];
                        message.queries.push($root.proto.Invocation.SQLInvocation.Query.decode(reader, reader.uint32()));
                        break;
                    case 2:
                        reader.skip().pos++;
                        if (message.endpoint === $util.emptyObject)
                            message.endpoint = {};
                        key = reader.string();
                        reader.pos++;
                        message.endpoint[key] = reader.string();
                        break;
                    case 3:
                        message.prepareStatement = reader.string();
                        break;
                    case 4:
                        message.prepareCall = reader.string();
                        break;
                    default:
                        reader.skipType(tag & 7);
                        break;
                    }
                }
                return message;
            };

            /**
             * Decodes a SQLInvocation message from the specified reader or buffer, length delimited.
             * @function decodeDelimited
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
             * @returns {proto.Invocation.SQLInvocation} SQLInvocation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            SQLInvocation.decodeDelimited = function decodeDelimited(reader) {
                if (!(reader instanceof $Reader))
                    reader = new $Reader(reader);
                return this.decode(reader, reader.uint32());
            };

            /**
             * Verifies a SQLInvocation message.
             * @function verify
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {Object.<string,*>} message Plain object to verify
             * @returns {string|null} `null` if valid, otherwise the reason why it is not
             */
            SQLInvocation.verify = function verify(message) {
                if (typeof message !== "object" || message === null)
                    return "object expected";
                if (message.queries != null && message.hasOwnProperty("queries")) {
                    if (!Array.isArray(message.queries))
                        return "queries: array expected";
                    for (var i = 0; i < message.queries.length; ++i) {
                        var error = $root.proto.Invocation.SQLInvocation.Query.verify(message.queries[i]);
                        if (error)
                            return "queries." + error;
                    }
                }
                if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                    if (!$util.isObject(message.endpoint))
                        return "endpoint: object expected";
                    var key = Object.keys(message.endpoint);
                    for (var i = 0; i < key.length; ++i)
                        if (!$util.isString(message.endpoint[key[i]]))
                            return "endpoint: string{k:string} expected";
                }
                if (message.prepareStatement != null && message.hasOwnProperty("prepareStatement"))
                    if (!$util.isString(message.prepareStatement))
                        return "prepareStatement: string expected";
                if (message.prepareCall != null && message.hasOwnProperty("prepareCall"))
                    if (!$util.isString(message.prepareCall))
                        return "prepareCall: string expected";
                return null;
            };

            /**
             * Creates a SQLInvocation message from a plain object. Also converts values to their respective internal types.
             * @function fromObject
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {Object.<string,*>} object Plain object
             * @returns {proto.Invocation.SQLInvocation} SQLInvocation
             */
            SQLInvocation.fromObject = function fromObject(object) {
                if (object instanceof $root.proto.Invocation.SQLInvocation)
                    return object;
                var message = new $root.proto.Invocation.SQLInvocation();
                if (object.queries) {
                    if (!Array.isArray(object.queries))
                        throw TypeError(".proto.Invocation.SQLInvocation.queries: array expected");
                    message.queries = [];
                    for (var i = 0; i < object.queries.length; ++i) {
                        if (typeof object.queries[i] !== "object")
                            throw TypeError(".proto.Invocation.SQLInvocation.queries: object expected");
                        message.queries[i] = $root.proto.Invocation.SQLInvocation.Query.fromObject(object.queries[i]);
                    }
                }
                if (object.endpoint) {
                    if (typeof object.endpoint !== "object")
                        throw TypeError(".proto.Invocation.SQLInvocation.endpoint: object expected");
                    message.endpoint = {};
                    for (var keys = Object.keys(object.endpoint), i = 0; i < keys.length; ++i)
                        message.endpoint[keys[i]] = String(object.endpoint[keys[i]]);
                }
                if (object.prepareStatement != null)
                    message.prepareStatement = String(object.prepareStatement);
                if (object.prepareCall != null)
                    message.prepareCall = String(object.prepareCall);
                return message;
            };

            /**
             * Creates a plain object from a SQLInvocation message. Also converts values to other types if specified.
             * @function toObject
             * @memberof proto.Invocation.SQLInvocation
             * @static
             * @param {proto.Invocation.SQLInvocation} message SQLInvocation
             * @param {$protobuf.IConversionOptions} [options] Conversion options
             * @returns {Object.<string,*>} Plain object
             */
            SQLInvocation.toObject = function toObject(message, options) {
                if (!options)
                    options = {};
                var object = {};
                if (options.arrays || options.defaults)
                    object.queries = [];
                if (options.objects || options.defaults)
                    object.endpoint = {};
                if (options.defaults) {
                    object.prepareStatement = "";
                    object.prepareCall = "";
                }
                if (message.queries && message.queries.length) {
                    object.queries = [];
                    for (var j = 0; j < message.queries.length; ++j)
                        object.queries[j] = $root.proto.Invocation.SQLInvocation.Query.toObject(message.queries[j], options);
                }
                var keys2;
                if (message.endpoint && (keys2 = Object.keys(message.endpoint)).length) {
                    object.endpoint = {};
                    for (var j = 0; j < keys2.length; ++j)
                        object.endpoint[keys2[j]] = message.endpoint[keys2[j]];
                }
                if (message.prepareStatement != null && message.hasOwnProperty("prepareStatement"))
                    object.prepareStatement = message.prepareStatement;
                if (message.prepareCall != null && message.hasOwnProperty("prepareCall"))
                    object.prepareCall = message.prepareCall;
                return object;
            };

            /**
             * Converts this SQLInvocation to JSON.
             * @function toJSON
             * @memberof proto.Invocation.SQLInvocation
             * @instance
             * @returns {Object.<string,*>} JSON object
             */
            SQLInvocation.prototype.toJSON = function toJSON() {
                return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
            };

            SQLInvocation.Query = (function() {

                /**
                 * Properties of a Query.
                 * @memberof proto.Invocation.SQLInvocation
                 * @interface IQuery
                 * @property {string} [query] Query query
                 * @property {Array.<string>} [tables] Query tables
                 * @property {Object.<string,string>} [parameter] Query parameter
                 */

                /**
                 * Constructs a new Query.
                 * @memberof proto.Invocation.SQLInvocation
                 * @classdesc Represents a Query.
                 * @constructor
                 * @param {proto.Invocation.SQLInvocation.IQuery=} [properties] Properties to set
                 */
                function Query(properties) {
                    this.tables = [];
                    this.parameter = {};
                    if (properties)
                        for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                            if (properties[keys[i]] != null)
                                this[keys[i]] = properties[keys[i]];
                }

                /**
                 * Query query.
                 * @member {string}query
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @instance
                 */
                Query.prototype.query = "";

                /**
                 * Query tables.
                 * @member {Array.<string>}tables
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @instance
                 */
                Query.prototype.tables = $util.emptyArray;

                /**
                 * Query parameter.
                 * @member {Object.<string,string>}parameter
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @instance
                 */
                Query.prototype.parameter = $util.emptyObject;

                /**
                 * Creates a new Query instance using the specified properties.
                 * @function create
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {proto.Invocation.SQLInvocation.IQuery=} [properties] Properties to set
                 * @returns {proto.Invocation.SQLInvocation.Query} Query instance
                 */
                Query.create = function create(properties) {
                    return new Query(properties);
                };

                /**
                 * Encodes the specified Query message. Does not implicitly {@link proto.Invocation.SQLInvocation.Query.verify|verify} messages.
                 * @function encode
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {proto.Invocation.SQLInvocation.IQuery} message Query message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Query.encode = function encode(message, writer) {
                    if (!writer)
                        writer = $Writer.create();
                    if (message.query != null && message.hasOwnProperty("query"))
                        writer.uint32(/* id 1, wireType 2 =*/10).string(message.query);
                    if (message.parameter != null && message.hasOwnProperty("parameter"))
                        for (var keys = Object.keys(message.parameter), i = 0; i < keys.length; ++i)
                            writer.uint32(/* id 2, wireType 2 =*/18).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.parameter[keys[i]]).ldelim();
                    if (message.tables != null && message.tables.length)
                        for (var i = 0; i < message.tables.length; ++i)
                            writer.uint32(/* id 3, wireType 2 =*/26).string(message.tables[i]);
                    return writer;
                };

                /**
                 * Encodes the specified Query message, length delimited. Does not implicitly {@link proto.Invocation.SQLInvocation.Query.verify|verify} messages.
                 * @function encodeDelimited
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {proto.Invocation.SQLInvocation.IQuery} message Query message or plain object to encode
                 * @param {$protobuf.Writer} [writer] Writer to encode to
                 * @returns {$protobuf.Writer} Writer
                 */
                Query.encodeDelimited = function encodeDelimited(message, writer) {
                    return this.encode(message, writer).ldelim();
                };

                /**
                 * Decodes a Query message from the specified reader or buffer.
                 * @function decode
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @param {number} [length] Message length if known beforehand
                 * @returns {proto.Invocation.SQLInvocation.Query} Query
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Query.decode = function decode(reader, length) {
                    if (!(reader instanceof $Reader))
                        reader = $Reader.create(reader);
                    var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Invocation.SQLInvocation.Query(), key;
                    while (reader.pos < end) {
                        var tag = reader.uint32();
                        switch (tag >>> 3) {
                        case 1:
                            message.query = reader.string();
                            break;
                        case 3:
                            if (!(message.tables && message.tables.length))
                                message.tables = [];
                            message.tables.push(reader.string());
                            break;
                        case 2:
                            reader.skip().pos++;
                            if (message.parameter === $util.emptyObject)
                                message.parameter = {};
                            key = reader.string();
                            reader.pos++;
                            message.parameter[key] = reader.string();
                            break;
                        default:
                            reader.skipType(tag & 7);
                            break;
                        }
                    }
                    return message;
                };

                /**
                 * Decodes a Query message from the specified reader or buffer, length delimited.
                 * @function decodeDelimited
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
                 * @returns {proto.Invocation.SQLInvocation.Query} Query
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                Query.decodeDelimited = function decodeDelimited(reader) {
                    if (!(reader instanceof $Reader))
                        reader = new $Reader(reader);
                    return this.decode(reader, reader.uint32());
                };

                /**
                 * Verifies a Query message.
                 * @function verify
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {Object.<string,*>} message Plain object to verify
                 * @returns {string|null} `null` if valid, otherwise the reason why it is not
                 */
                Query.verify = function verify(message) {
                    if (typeof message !== "object" || message === null)
                        return "object expected";
                    if (message.query != null && message.hasOwnProperty("query"))
                        if (!$util.isString(message.query))
                            return "query: string expected";
                    if (message.tables != null && message.hasOwnProperty("tables")) {
                        if (!Array.isArray(message.tables))
                            return "tables: array expected";
                        for (var i = 0; i < message.tables.length; ++i)
                            if (!$util.isString(message.tables[i]))
                                return "tables: string[] expected";
                    }
                    if (message.parameter != null && message.hasOwnProperty("parameter")) {
                        if (!$util.isObject(message.parameter))
                            return "parameter: object expected";
                        var key = Object.keys(message.parameter);
                        for (var i = 0; i < key.length; ++i)
                            if (!$util.isString(message.parameter[key[i]]))
                                return "parameter: string{k:string} expected";
                    }
                    return null;
                };

                /**
                 * Creates a Query message from a plain object. Also converts values to their respective internal types.
                 * @function fromObject
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {Object.<string,*>} object Plain object
                 * @returns {proto.Invocation.SQLInvocation.Query} Query
                 */
                Query.fromObject = function fromObject(object) {
                    if (object instanceof $root.proto.Invocation.SQLInvocation.Query)
                        return object;
                    var message = new $root.proto.Invocation.SQLInvocation.Query();
                    if (object.query != null)
                        message.query = String(object.query);
                    if (object.tables) {
                        if (!Array.isArray(object.tables))
                            throw TypeError(".proto.Invocation.SQLInvocation.Query.tables: array expected");
                        message.tables = [];
                        for (var i = 0; i < object.tables.length; ++i)
                            message.tables[i] = String(object.tables[i]);
                    }
                    if (object.parameter) {
                        if (typeof object.parameter !== "object")
                            throw TypeError(".proto.Invocation.SQLInvocation.Query.parameter: object expected");
                        message.parameter = {};
                        for (var keys = Object.keys(object.parameter), i = 0; i < keys.length; ++i)
                            message.parameter[keys[i]] = String(object.parameter[keys[i]]);
                    }
                    return message;
                };

                /**
                 * Creates a plain object from a Query message. Also converts values to other types if specified.
                 * @function toObject
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @static
                 * @param {proto.Invocation.SQLInvocation.Query} message Query
                 * @param {$protobuf.IConversionOptions} [options] Conversion options
                 * @returns {Object.<string,*>} Plain object
                 */
                Query.toObject = function toObject(message, options) {
                    if (!options)
                        options = {};
                    var object = {};
                    if (options.arrays || options.defaults)
                        object.tables = [];
                    if (options.objects || options.defaults)
                        object.parameter = {};
                    if (options.defaults)
                        object.query = "";
                    if (message.query != null && message.hasOwnProperty("query"))
                        object.query = message.query;
                    var keys2;
                    if (message.parameter && (keys2 = Object.keys(message.parameter)).length) {
                        object.parameter = {};
                        for (var j = 0; j < keys2.length; ++j)
                            object.parameter[keys2[j]] = message.parameter[keys2[j]];
                    }
                    if (message.tables && message.tables.length) {
                        object.tables = [];
                        for (var j = 0; j < message.tables.length; ++j)
                            object.tables[j] = message.tables[j];
                    }
                    return object;
                };

                /**
                 * Converts this Query to JSON.
                 * @function toJSON
                 * @memberof proto.Invocation.SQLInvocation.Query
                 * @instance
                 * @returns {Object.<string,*>} JSON object
                 */
                Query.prototype.toJSON = function toJSON() {
                    return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
                };

                return Query;
            })();

            return SQLInvocation;
        })();

        return Invocation;
    })();

    proto.Datapoint = (function() {

        /**
         * Properties of a Datapoint.
         * @memberof proto
         * @interface IDatapoint
         * @property {Object.<string,string>} [context] Datapoint context
         * @property {Array.<proto.IError>} [errors] Datapoint errors
         * @property {Object.<string,string>} [endpoint] Datapoint endpoint
         * @property {Object.<string,string>} [meta] Datapoint meta
         * @property {Array.<proto.IDetection>} [detections] Datapoint detections
         * @property {Object.<string,string>} [input] Datapoint input
         * @property {proto.IInvocation} [invocation] Datapoint invocation
         * @property {Array.<proto.IVulnerability>} [vulnerabilities] Datapoint vulnerabilities
         * @property {Array.<proto.IDataLeakage>} [dataLeakages] Datapoint dataLeakages
         * @property {Object.<string,proto.IPersonalData>} [personalData] Datapoint personalData
         */

        /**
         * Constructs a new Datapoint.
         * @memberof proto
         * @classdesc Represents a Datapoint.
         * @constructor
         * @param {proto.IDatapoint=} [properties] Properties to set
         */
        function Datapoint(properties) {
            this.context = {};
            this.errors = [];
            this.endpoint = {};
            this.meta = {};
            this.detections = [];
            this.input = {};
            this.vulnerabilities = [];
            this.dataLeakages = [];
            this.personalData = {};
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Datapoint context.
         * @member {Object.<string,string>}context
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.context = $util.emptyObject;

        /**
         * Datapoint errors.
         * @member {Array.<proto.IError>}errors
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.errors = $util.emptyArray;

        /**
         * Datapoint endpoint.
         * @member {Object.<string,string>}endpoint
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.endpoint = $util.emptyObject;

        /**
         * Datapoint meta.
         * @member {Object.<string,string>}meta
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.meta = $util.emptyObject;

        /**
         * Datapoint detections.
         * @member {Array.<proto.IDetection>}detections
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.detections = $util.emptyArray;

        /**
         * Datapoint input.
         * @member {Object.<string,string>}input
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.input = $util.emptyObject;

        /**
         * Datapoint invocation.
         * @member {(proto.IInvocation|null|undefined)}invocation
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.invocation = null;

        /**
         * Datapoint vulnerabilities.
         * @member {Array.<proto.IVulnerability>}vulnerabilities
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.vulnerabilities = $util.emptyArray;

        /**
         * Datapoint dataLeakages.
         * @member {Array.<proto.IDataLeakage>}dataLeakages
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.dataLeakages = $util.emptyArray;

        /**
         * Datapoint personalData.
         * @member {Object.<string,proto.IPersonalData>}personalData
         * @memberof proto.Datapoint
         * @instance
         */
        Datapoint.prototype.personalData = $util.emptyObject;

        /**
         * Creates a new Datapoint instance using the specified properties.
         * @function create
         * @memberof proto.Datapoint
         * @static
         * @param {proto.IDatapoint=} [properties] Properties to set
         * @returns {proto.Datapoint} Datapoint instance
         */
        Datapoint.create = function create(properties) {
            return new Datapoint(properties);
        };

        /**
         * Encodes the specified Datapoint message. Does not implicitly {@link proto.Datapoint.verify|verify} messages.
         * @function encode
         * @memberof proto.Datapoint
         * @static
         * @param {proto.IDatapoint} message Datapoint message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Datapoint.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.context != null && message.hasOwnProperty("context"))
                for (var keys = Object.keys(message.context), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.context[keys[i]]).ldelim();
            if (message.errors != null && message.errors.length)
                for (var i = 0; i < message.errors.length; ++i)
                    $root.proto.Error.encode(message.errors[i], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim();
            if (message.endpoint != null && message.hasOwnProperty("endpoint"))
                for (var keys = Object.keys(message.endpoint), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 3, wireType 2 =*/26).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.endpoint[keys[i]]).ldelim();
            if (message.meta != null && message.hasOwnProperty("meta"))
                for (var keys = Object.keys(message.meta), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 4, wireType 2 =*/34).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.meta[keys[i]]).ldelim();
            if (message.detections != null && message.detections.length)
                for (var i = 0; i < message.detections.length; ++i)
                    $root.proto.Detection.encode(message.detections[i], writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.input != null && message.hasOwnProperty("input"))
                for (var keys = Object.keys(message.input), i = 0; i < keys.length; ++i)
                    writer.uint32(/* id 6, wireType 2 =*/50).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]).uint32(/* id 2, wireType 2 =*/18).string(message.input[keys[i]]).ldelim();
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                $root.proto.Invocation.encode(message.invocation, writer.uint32(/* id 7, wireType 2 =*/58).fork()).ldelim();
            if (message.vulnerabilities != null && message.vulnerabilities.length)
                for (var i = 0; i < message.vulnerabilities.length; ++i)
                    $root.proto.Vulnerability.encode(message.vulnerabilities[i], writer.uint32(/* id 9, wireType 2 =*/74).fork()).ldelim();
            if (message.dataLeakages != null && message.dataLeakages.length)
                for (var i = 0; i < message.dataLeakages.length; ++i)
                    $root.proto.DataLeakage.encode(message.dataLeakages[i], writer.uint32(/* id 10, wireType 2 =*/82).fork()).ldelim();
            if (message.personalData != null && message.hasOwnProperty("personalData"))
                for (var keys = Object.keys(message.personalData), i = 0; i < keys.length; ++i) {
                    writer.uint32(/* id 11, wireType 2 =*/90).fork().uint32(/* id 1, wireType 2 =*/10).string(keys[i]);
                    $root.proto.PersonalData.encode(message.personalData[keys[i]], writer.uint32(/* id 2, wireType 2 =*/18).fork()).ldelim().ldelim();
                }
            return writer;
        };

        /**
         * Encodes the specified Datapoint message, length delimited. Does not implicitly {@link proto.Datapoint.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Datapoint
         * @static
         * @param {proto.IDatapoint} message Datapoint message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Datapoint.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Datapoint message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Datapoint
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Datapoint} Datapoint
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Datapoint.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Datapoint(), key;
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    reader.skip().pos++;
                    if (message.context === $util.emptyObject)
                        message.context = {};
                    key = reader.string();
                    reader.pos++;
                    message.context[key] = reader.string();
                    break;
                case 2:
                    if (!(message.errors && message.errors.length))
                        message.errors = [];
                    message.errors.push($root.proto.Error.decode(reader, reader.uint32()));
                    break;
                case 3:
                    reader.skip().pos++;
                    if (message.endpoint === $util.emptyObject)
                        message.endpoint = {};
                    key = reader.string();
                    reader.pos++;
                    message.endpoint[key] = reader.string();
                    break;
                case 4:
                    reader.skip().pos++;
                    if (message.meta === $util.emptyObject)
                        message.meta = {};
                    key = reader.string();
                    reader.pos++;
                    message.meta[key] = reader.string();
                    break;
                case 5:
                    if (!(message.detections && message.detections.length))
                        message.detections = [];
                    message.detections.push($root.proto.Detection.decode(reader, reader.uint32()));
                    break;
                case 6:
                    reader.skip().pos++;
                    if (message.input === $util.emptyObject)
                        message.input = {};
                    key = reader.string();
                    reader.pos++;
                    message.input[key] = reader.string();
                    break;
                case 7:
                    message.invocation = $root.proto.Invocation.decode(reader, reader.uint32());
                    break;
                case 9:
                    if (!(message.vulnerabilities && message.vulnerabilities.length))
                        message.vulnerabilities = [];
                    message.vulnerabilities.push($root.proto.Vulnerability.decode(reader, reader.uint32()));
                    break;
                case 10:
                    if (!(message.dataLeakages && message.dataLeakages.length))
                        message.dataLeakages = [];
                    message.dataLeakages.push($root.proto.DataLeakage.decode(reader, reader.uint32()));
                    break;
                case 11:
                    reader.skip().pos++;
                    if (message.personalData === $util.emptyObject)
                        message.personalData = {};
                    key = reader.string();
                    reader.pos++;
                    message.personalData[key] = $root.proto.PersonalData.decode(reader, reader.uint32());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Datapoint message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Datapoint
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Datapoint} Datapoint
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Datapoint.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Datapoint message.
         * @function verify
         * @memberof proto.Datapoint
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Datapoint.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.context != null && message.hasOwnProperty("context")) {
                if (!$util.isObject(message.context))
                    return "context: object expected";
                var key = Object.keys(message.context);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.context[key[i]]))
                        return "context: string{k:string} expected";
            }
            if (message.errors != null && message.hasOwnProperty("errors")) {
                if (!Array.isArray(message.errors))
                    return "errors: array expected";
                for (var i = 0; i < message.errors.length; ++i) {
                    var error = $root.proto.Error.verify(message.errors[i]);
                    if (error)
                        return "errors." + error;
                }
            }
            if (message.endpoint != null && message.hasOwnProperty("endpoint")) {
                if (!$util.isObject(message.endpoint))
                    return "endpoint: object expected";
                var key = Object.keys(message.endpoint);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.endpoint[key[i]]))
                        return "endpoint: string{k:string} expected";
            }
            if (message.meta != null && message.hasOwnProperty("meta")) {
                if (!$util.isObject(message.meta))
                    return "meta: object expected";
                var key = Object.keys(message.meta);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.meta[key[i]]))
                        return "meta: string{k:string} expected";
            }
            if (message.detections != null && message.hasOwnProperty("detections")) {
                if (!Array.isArray(message.detections))
                    return "detections: array expected";
                for (var i = 0; i < message.detections.length; ++i) {
                    error = $root.proto.Detection.verify(message.detections[i]);
                    if (error)
                        return "detections." + error;
                }
            }
            if (message.input != null && message.hasOwnProperty("input")) {
                if (!$util.isObject(message.input))
                    return "input: object expected";
                var key = Object.keys(message.input);
                for (var i = 0; i < key.length; ++i)
                    if (!$util.isString(message.input[key[i]]))
                        return "input: string{k:string} expected";
            }
            if (message.invocation != null && message.hasOwnProperty("invocation")) {
                error = $root.proto.Invocation.verify(message.invocation);
                if (error)
                    return "invocation." + error;
            }
            if (message.vulnerabilities != null && message.hasOwnProperty("vulnerabilities")) {
                if (!Array.isArray(message.vulnerabilities))
                    return "vulnerabilities: array expected";
                for (var i = 0; i < message.vulnerabilities.length; ++i) {
                    error = $root.proto.Vulnerability.verify(message.vulnerabilities[i]);
                    if (error)
                        return "vulnerabilities." + error;
                }
            }
            if (message.dataLeakages != null && message.hasOwnProperty("dataLeakages")) {
                if (!Array.isArray(message.dataLeakages))
                    return "dataLeakages: array expected";
                for (var i = 0; i < message.dataLeakages.length; ++i) {
                    error = $root.proto.DataLeakage.verify(message.dataLeakages[i]);
                    if (error)
                        return "dataLeakages." + error;
                }
            }
            if (message.personalData != null && message.hasOwnProperty("personalData")) {
                if (!$util.isObject(message.personalData))
                    return "personalData: object expected";
                var key = Object.keys(message.personalData);
                for (var i = 0; i < key.length; ++i) {
                    error = $root.proto.PersonalData.verify(message.personalData[key[i]]);
                    if (error)
                        return "personalData." + error;
                }
            }
            return null;
        };

        /**
         * Creates a Datapoint message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Datapoint
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Datapoint} Datapoint
         */
        Datapoint.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Datapoint)
                return object;
            var message = new $root.proto.Datapoint();
            if (object.context) {
                if (typeof object.context !== "object")
                    throw TypeError(".proto.Datapoint.context: object expected");
                message.context = {};
                for (var keys = Object.keys(object.context), i = 0; i < keys.length; ++i)
                    message.context[keys[i]] = String(object.context[keys[i]]);
            }
            if (object.errors) {
                if (!Array.isArray(object.errors))
                    throw TypeError(".proto.Datapoint.errors: array expected");
                message.errors = [];
                for (var i = 0; i < object.errors.length; ++i) {
                    if (typeof object.errors[i] !== "object")
                        throw TypeError(".proto.Datapoint.errors: object expected");
                    message.errors[i] = $root.proto.Error.fromObject(object.errors[i]);
                }
            }
            if (object.endpoint) {
                if (typeof object.endpoint !== "object")
                    throw TypeError(".proto.Datapoint.endpoint: object expected");
                message.endpoint = {};
                for (var keys = Object.keys(object.endpoint), i = 0; i < keys.length; ++i)
                    message.endpoint[keys[i]] = String(object.endpoint[keys[i]]);
            }
            if (object.meta) {
                if (typeof object.meta !== "object")
                    throw TypeError(".proto.Datapoint.meta: object expected");
                message.meta = {};
                for (var keys = Object.keys(object.meta), i = 0; i < keys.length; ++i)
                    message.meta[keys[i]] = String(object.meta[keys[i]]);
            }
            if (object.detections) {
                if (!Array.isArray(object.detections))
                    throw TypeError(".proto.Datapoint.detections: array expected");
                message.detections = [];
                for (var i = 0; i < object.detections.length; ++i) {
                    if (typeof object.detections[i] !== "object")
                        throw TypeError(".proto.Datapoint.detections: object expected");
                    message.detections[i] = $root.proto.Detection.fromObject(object.detections[i]);
                }
            }
            if (object.input) {
                if (typeof object.input !== "object")
                    throw TypeError(".proto.Datapoint.input: object expected");
                message.input = {};
                for (var keys = Object.keys(object.input), i = 0; i < keys.length; ++i)
                    message.input[keys[i]] = String(object.input[keys[i]]);
            }
            if (object.invocation != null) {
                if (typeof object.invocation !== "object")
                    throw TypeError(".proto.Datapoint.invocation: object expected");
                message.invocation = $root.proto.Invocation.fromObject(object.invocation);
            }
            if (object.vulnerabilities) {
                if (!Array.isArray(object.vulnerabilities))
                    throw TypeError(".proto.Datapoint.vulnerabilities: array expected");
                message.vulnerabilities = [];
                for (var i = 0; i < object.vulnerabilities.length; ++i) {
                    if (typeof object.vulnerabilities[i] !== "object")
                        throw TypeError(".proto.Datapoint.vulnerabilities: object expected");
                    message.vulnerabilities[i] = $root.proto.Vulnerability.fromObject(object.vulnerabilities[i]);
                }
            }
            if (object.dataLeakages) {
                if (!Array.isArray(object.dataLeakages))
                    throw TypeError(".proto.Datapoint.dataLeakages: array expected");
                message.dataLeakages = [];
                for (var i = 0; i < object.dataLeakages.length; ++i) {
                    if (typeof object.dataLeakages[i] !== "object")
                        throw TypeError(".proto.Datapoint.dataLeakages: object expected");
                    message.dataLeakages[i] = $root.proto.DataLeakage.fromObject(object.dataLeakages[i]);
                }
            }
            if (object.personalData) {
                if (typeof object.personalData !== "object")
                    throw TypeError(".proto.Datapoint.personalData: object expected");
                message.personalData = {};
                for (var keys = Object.keys(object.personalData), i = 0; i < keys.length; ++i) {
                    if (typeof object.personalData[keys[i]] !== "object")
                        throw TypeError(".proto.Datapoint.personalData: object expected");
                    message.personalData[keys[i]] = $root.proto.PersonalData.fromObject(object.personalData[keys[i]]);
                }
            }
            return message;
        };

        /**
         * Creates a plain object from a Datapoint message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Datapoint
         * @static
         * @param {proto.Datapoint} message Datapoint
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Datapoint.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults) {
                object.errors = [];
                object.detections = [];
                object.vulnerabilities = [];
                object.dataLeakages = [];
            }
            if (options.objects || options.defaults) {
                object.context = {};
                object.endpoint = {};
                object.meta = {};
                object.input = {};
                object.personalData = {};
            }
            if (options.defaults)
                object.invocation = null;
            var keys2;
            if (message.context && (keys2 = Object.keys(message.context)).length) {
                object.context = {};
                for (var j = 0; j < keys2.length; ++j)
                    object.context[keys2[j]] = message.context[keys2[j]];
            }
            if (message.errors && message.errors.length) {
                object.errors = [];
                for (var j = 0; j < message.errors.length; ++j)
                    object.errors[j] = $root.proto.Error.toObject(message.errors[j], options);
            }
            if (message.endpoint && (keys2 = Object.keys(message.endpoint)).length) {
                object.endpoint = {};
                for (var j = 0; j < keys2.length; ++j)
                    object.endpoint[keys2[j]] = message.endpoint[keys2[j]];
            }
            if (message.meta && (keys2 = Object.keys(message.meta)).length) {
                object.meta = {};
                for (var j = 0; j < keys2.length; ++j)
                    object.meta[keys2[j]] = message.meta[keys2[j]];
            }
            if (message.detections && message.detections.length) {
                object.detections = [];
                for (var j = 0; j < message.detections.length; ++j)
                    object.detections[j] = $root.proto.Detection.toObject(message.detections[j], options);
            }
            if (message.input && (keys2 = Object.keys(message.input)).length) {
                object.input = {};
                for (var j = 0; j < keys2.length; ++j)
                    object.input[keys2[j]] = message.input[keys2[j]];
            }
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                object.invocation = $root.proto.Invocation.toObject(message.invocation, options);
            if (message.vulnerabilities && message.vulnerabilities.length) {
                object.vulnerabilities = [];
                for (var j = 0; j < message.vulnerabilities.length; ++j)
                    object.vulnerabilities[j] = $root.proto.Vulnerability.toObject(message.vulnerabilities[j], options);
            }
            if (message.dataLeakages && message.dataLeakages.length) {
                object.dataLeakages = [];
                for (var j = 0; j < message.dataLeakages.length; ++j)
                    object.dataLeakages[j] = $root.proto.DataLeakage.toObject(message.dataLeakages[j], options);
            }
            if (message.personalData && (keys2 = Object.keys(message.personalData)).length) {
                object.personalData = {};
                for (var j = 0; j < keys2.length; ++j)
                    object.personalData[keys2[j]] = $root.proto.PersonalData.toObject(message.personalData[keys2[j]], options);
            }
            return object;
        };

        /**
         * Converts this Datapoint to JSON.
         * @function toJSON
         * @memberof proto.Datapoint
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Datapoint.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return Datapoint;
    })();

    proto.PersonalData = (function() {

        /**
         * Properties of a PersonalData.
         * @memberof proto
         * @interface IPersonalData
         * @property {Array.<string>} [value] PersonalData value
         */

        /**
         * Constructs a new PersonalData.
         * @memberof proto
         * @classdesc Represents a PersonalData.
         * @constructor
         * @param {proto.IPersonalData=} [properties] Properties to set
         */
        function PersonalData(properties) {
            this.value = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * PersonalData value.
         * @member {Array.<string>}value
         * @memberof proto.PersonalData
         * @instance
         */
        PersonalData.prototype.value = $util.emptyArray;

        /**
         * Creates a new PersonalData instance using the specified properties.
         * @function create
         * @memberof proto.PersonalData
         * @static
         * @param {proto.IPersonalData=} [properties] Properties to set
         * @returns {proto.PersonalData} PersonalData instance
         */
        PersonalData.create = function create(properties) {
            return new PersonalData(properties);
        };

        /**
         * Encodes the specified PersonalData message. Does not implicitly {@link proto.PersonalData.verify|verify} messages.
         * @function encode
         * @memberof proto.PersonalData
         * @static
         * @param {proto.IPersonalData} message PersonalData message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PersonalData.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.value != null && message.value.length)
                for (var i = 0; i < message.value.length; ++i)
                    writer.uint32(/* id 1, wireType 2 =*/10).string(message.value[i]);
            return writer;
        };

        /**
         * Encodes the specified PersonalData message, length delimited. Does not implicitly {@link proto.PersonalData.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.PersonalData
         * @static
         * @param {proto.IPersonalData} message PersonalData message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        PersonalData.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a PersonalData message from the specified reader or buffer.
         * @function decode
         * @memberof proto.PersonalData
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.PersonalData} PersonalData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PersonalData.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.PersonalData();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    if (!(message.value && message.value.length))
                        message.value = [];
                    message.value.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a PersonalData message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.PersonalData
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.PersonalData} PersonalData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        PersonalData.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a PersonalData message.
         * @function verify
         * @memberof proto.PersonalData
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        PersonalData.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.value != null && message.hasOwnProperty("value")) {
                if (!Array.isArray(message.value))
                    return "value: array expected";
                for (var i = 0; i < message.value.length; ++i)
                    if (!$util.isString(message.value[i]))
                        return "value: string[] expected";
            }
            return null;
        };

        /**
         * Creates a PersonalData message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.PersonalData
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.PersonalData} PersonalData
         */
        PersonalData.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.PersonalData)
                return object;
            var message = new $root.proto.PersonalData();
            if (object.value) {
                if (!Array.isArray(object.value))
                    throw TypeError(".proto.PersonalData.value: array expected");
                message.value = [];
                for (var i = 0; i < object.value.length; ++i)
                    message.value[i] = String(object.value[i]);
            }
            return message;
        };

        /**
         * Creates a plain object from a PersonalData message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.PersonalData
         * @static
         * @param {proto.PersonalData} message PersonalData
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        PersonalData.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults)
                object.value = [];
            if (message.value && message.value.length) {
                object.value = [];
                for (var j = 0; j < message.value.length; ++j)
                    object.value[j] = message.value[j];
            }
            return object;
        };

        /**
         * Converts this PersonalData to JSON.
         * @function toJSON
         * @memberof proto.PersonalData
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        PersonalData.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return PersonalData;
    })();

    proto.DatapointReceiver = (function() {

        /**
         * Constructs a new DatapointReceiver service.
         * @memberof proto
         * @classdesc Represents a DatapointReceiver
         * @extends $protobuf.rpc.Service
         * @constructor
         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
         */
        function DatapointReceiver(rpcImpl, requestDelimited, responseDelimited) {
            $protobuf.rpc.Service.call(this, rpcImpl, requestDelimited, responseDelimited);
        }

        (DatapointReceiver.prototype = Object.create($protobuf.rpc.Service.prototype)).constructor = DatapointReceiver;

        /**
         * Creates new DatapointReceiver service using the specified rpc implementation.
         * @function create
         * @memberof proto.DatapointReceiver
         * @static
         * @param {$protobuf.RPCImpl} rpcImpl RPC implementation
         * @param {boolean} [requestDelimited=false] Whether requests are length-delimited
         * @param {boolean} [responseDelimited=false] Whether responses are length-delimited
         * @returns {DatapointReceiver} RPC service. Useful where requests and/or responses are streamed.
         */
        DatapointReceiver.create = function create(rpcImpl, requestDelimited, responseDelimited) {
            return new this(rpcImpl, requestDelimited, responseDelimited);
        };

        /**
         * Callback as used by {@link proto.DatapointReceiver#receiveDatapoint}.
         * @memberof proto.DatapointReceiver
         * @typedef receiveDatapointCallback
         * @type {function}
         * @param {Error|null} error Error, if any
         * @param {proto.Reply} [response] Reply
         */

        /**
         * Calls receiveDatapoint.
         * @function .receiveDatapoint
         * @memberof proto.DatapointReceiver
         * @instance
         * @param {proto.IDatapoint} request Datapoint message or plain object
         * @param {proto.DatapointReceiver.receiveDatapointCallback} callback Node-style callback called with the error, if any, and Reply
         * @returns {undefined}
         * @variation 1
         */
        DatapointReceiver.prototype.receiveDatapoint = function receiveDatapoint(request, callback) {
            return this.rpcCall(receiveDatapoint, $root.proto.Datapoint, $root.proto.Reply, request, callback);
        };

        /**
         * Calls receiveDatapoint.
         * @function receiveDatapoint
         * @memberof proto.DatapointReceiver
         * @instance
         * @param {proto.IDatapoint} request Datapoint message or plain object
         * @returns {Promise<proto.Reply>} Promise
         * @variation 2
         */

        return DatapointReceiver;
    })();

    proto.Reply = (function() {

        /**
         * Properties of a Reply.
         * @memberof proto
         * @interface IReply
         * @property {string} [message] Reply message
         */

        /**
         * Constructs a new Reply.
         * @memberof proto
         * @classdesc Represents a Reply.
         * @constructor
         * @param {proto.IReply=} [properties] Properties to set
         */
        function Reply(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Reply message.
         * @member {string}message
         * @memberof proto.Reply
         * @instance
         */
        Reply.prototype.message = "";

        /**
         * Creates a new Reply instance using the specified properties.
         * @function create
         * @memberof proto.Reply
         * @static
         * @param {proto.IReply=} [properties] Properties to set
         * @returns {proto.Reply} Reply instance
         */
        Reply.create = function create(properties) {
            return new Reply(properties);
        };

        /**
         * Encodes the specified Reply message. Does not implicitly {@link proto.Reply.verify|verify} messages.
         * @function encode
         * @memberof proto.Reply
         * @static
         * @param {proto.IReply} message Reply message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Reply.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.message != null && message.hasOwnProperty("message"))
                writer.uint32(/* id 1, wireType 2 =*/10).string(message.message);
            return writer;
        };

        /**
         * Encodes the specified Reply message, length delimited. Does not implicitly {@link proto.Reply.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Reply
         * @static
         * @param {proto.IReply} message Reply message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Reply.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Reply message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Reply
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Reply} Reply
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Reply.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Reply();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.message = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Reply message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Reply
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Reply} Reply
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Reply.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Reply message.
         * @function verify
         * @memberof proto.Reply
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Reply.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.message != null && message.hasOwnProperty("message"))
                if (!$util.isString(message.message))
                    return "message: string expected";
            return null;
        };

        /**
         * Creates a Reply message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Reply
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Reply} Reply
         */
        Reply.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Reply)
                return object;
            var message = new $root.proto.Reply();
            if (object.message != null)
                message.message = String(object.message);
            return message;
        };

        /**
         * Creates a plain object from a Reply message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Reply
         * @static
         * @param {proto.Reply} message Reply
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Reply.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.defaults)
                object.message = "";
            if (message.message != null && message.hasOwnProperty("message"))
                object.message = message.message;
            return object;
        };

        /**
         * Converts this Reply to JSON.
         * @function toJSON
         * @memberof proto.Reply
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Reply.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return Reply;
    })();

    proto.Error = (function() {

        /**
         * Properties of an Error.
         * @memberof proto
         * @interface IError
         * @property {number} [code] Error code
         * @property {string} [description] Error description
         * @property {string} [location] Error location
         * @property {number} [line] Error line
         * @property {string} [type] Error type
         * @property {proto.GeneratedBy} [generatedby] Error generatedby
         * @property {number|Long} [hash] Error hash
         * @property {Array.<string>} [context] Error context
         */

        /**
         * Constructs a new Error.
         * @memberof proto
         * @classdesc Represents an Error.
         * @constructor
         * @param {proto.IError=} [properties] Properties to set
         */
        function Error(properties) {
            this.context = [];
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Error code.
         * @member {number}code
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.code = 0;

        /**
         * Error description.
         * @member {string}description
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.description = "";

        /**
         * Error location.
         * @member {string}location
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.location = "";

        /**
         * Error line.
         * @member {number}line
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.line = 0;

        /**
         * Error type.
         * @member {string}type
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.type = "";

        /**
         * Error generatedby.
         * @member {proto.GeneratedBy}generatedby
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.generatedby = 0;

        /**
         * Error hash.
         * @member {number|Long}hash
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.hash = $util.Long ? $util.Long.fromBits(0,0,false) : 0;

        /**
         * Error context.
         * @member {Array.<string>}context
         * @memberof proto.Error
         * @instance
         */
        Error.prototype.context = $util.emptyArray;

        /**
         * Creates a new Error instance using the specified properties.
         * @function create
         * @memberof proto.Error
         * @static
         * @param {proto.IError=} [properties] Properties to set
         * @returns {proto.Error} Error instance
         */
        Error.create = function create(properties) {
            return new Error(properties);
        };

        /**
         * Encodes the specified Error message. Does not implicitly {@link proto.Error.verify|verify} messages.
         * @function encode
         * @memberof proto.Error
         * @static
         * @param {proto.IError} message Error message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Error.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.code != null && message.hasOwnProperty("code"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.code);
            if (message.description != null && message.hasOwnProperty("description"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.description);
            if (message.location != null && message.hasOwnProperty("location"))
                writer.uint32(/* id 3, wireType 2 =*/26).string(message.location);
            if (message.line != null && message.hasOwnProperty("line"))
                writer.uint32(/* id 4, wireType 0 =*/32).int32(message.line);
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 5, wireType 2 =*/42).string(message.type);
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                writer.uint32(/* id 6, wireType 0 =*/48).int32(message.generatedby);
            if (message.hash != null && message.hasOwnProperty("hash"))
                writer.uint32(/* id 7, wireType 0 =*/56).int64(message.hash);
            if (message.context != null && message.context.length)
                for (var i = 0; i < message.context.length; ++i)
                    writer.uint32(/* id 8, wireType 2 =*/66).string(message.context[i]);
            return writer;
        };

        /**
         * Encodes the specified Error message, length delimited. Does not implicitly {@link proto.Error.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Error
         * @static
         * @param {proto.IError} message Error message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Error.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes an Error message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Error
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Error} Error
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Error.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Error();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.code = reader.int32();
                    break;
                case 2:
                    message.description = reader.string();
                    break;
                case 3:
                    message.location = reader.string();
                    break;
                case 4:
                    message.line = reader.int32();
                    break;
                case 5:
                    message.type = reader.string();
                    break;
                case 6:
                    message.generatedby = reader.int32();
                    break;
                case 7:
                    message.hash = reader.int64();
                    break;
                case 8:
                    if (!(message.context && message.context.length))
                        message.context = [];
                    message.context.push(reader.string());
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes an Error message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Error
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Error} Error
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Error.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies an Error message.
         * @function verify
         * @memberof proto.Error
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Error.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.code != null && message.hasOwnProperty("code"))
                if (!$util.isInteger(message.code))
                    return "code: integer expected";
            if (message.description != null && message.hasOwnProperty("description"))
                if (!$util.isString(message.description))
                    return "description: string expected";
            if (message.location != null && message.hasOwnProperty("location"))
                if (!$util.isString(message.location))
                    return "location: string expected";
            if (message.line != null && message.hasOwnProperty("line"))
                if (!$util.isInteger(message.line))
                    return "line: integer expected";
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                switch (message.generatedby) {
                default:
                    return "generatedby: enum value expected";
                case 0:
                case 1:
                case 2:
                    break;
                }
            if (message.hash != null && message.hasOwnProperty("hash"))
                if (!$util.isInteger(message.hash) && !(message.hash && $util.isInteger(message.hash.low) && $util.isInteger(message.hash.high)))
                    return "hash: integer|Long expected";
            if (message.context != null && message.hasOwnProperty("context")) {
                if (!Array.isArray(message.context))
                    return "context: array expected";
                for (var i = 0; i < message.context.length; ++i)
                    if (!$util.isString(message.context[i]))
                        return "context: string[] expected";
            }
            return null;
        };

        /**
         * Creates an Error message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Error
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Error} Error
         */
        Error.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Error)
                return object;
            var message = new $root.proto.Error();
            if (object.code != null)
                message.code = object.code | 0;
            if (object.description != null)
                message.description = String(object.description);
            if (object.location != null)
                message.location = String(object.location);
            if (object.line != null)
                message.line = object.line | 0;
            if (object.type != null)
                message.type = String(object.type);
            switch (object.generatedby) {
            case "BITBRAIN":
            case 0:
                message.generatedby = 0;
                break;
            case "PLUGIN":
            case 1:
                message.generatedby = 1;
                break;
            case "MODSECURITY":
            case 2:
                message.generatedby = 2;
                break;
            }
            if (object.hash != null)
                if ($util.Long)
                    (message.hash = $util.Long.fromValue(object.hash)).unsigned = false;
                else if (typeof object.hash === "string")
                    message.hash = parseInt(object.hash, 10);
                else if (typeof object.hash === "number")
                    message.hash = object.hash;
                else if (typeof object.hash === "object")
                    message.hash = new $util.LongBits(object.hash.low >>> 0, object.hash.high >>> 0).toNumber();
            if (object.context) {
                if (!Array.isArray(object.context))
                    throw TypeError(".proto.Error.context: array expected");
                message.context = [];
                for (var i = 0; i < object.context.length; ++i)
                    message.context[i] = String(object.context[i]);
            }
            return message;
        };

        /**
         * Creates a plain object from an Error message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Error
         * @static
         * @param {proto.Error} message Error
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Error.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.arrays || options.defaults)
                object.context = [];
            if (options.defaults) {
                object.code = 0;
                object.description = "";
                object.location = "";
                object.line = 0;
                object.type = "";
                object.generatedby = options.enums === String ? "BITBRAIN" : 0;
                if ($util.Long) {
                    var long = new $util.Long(0, 0, false);
                    object.hash = options.longs === String ? long.toString() : options.longs === Number ? long.toNumber() : long;
                } else
                    object.hash = options.longs === String ? "0" : 0;
            }
            if (message.code != null && message.hasOwnProperty("code"))
                object.code = message.code;
            if (message.description != null && message.hasOwnProperty("description"))
                object.description = message.description;
            if (message.location != null && message.hasOwnProperty("location"))
                object.location = message.location;
            if (message.line != null && message.hasOwnProperty("line"))
                object.line = message.line;
            if (message.type != null && message.hasOwnProperty("type"))
                object.type = message.type;
            if (message.generatedby != null && message.hasOwnProperty("generatedby"))
                object.generatedby = options.enums === String ? $root.proto.GeneratedBy[message.generatedby] : message.generatedby;
            if (message.hash != null && message.hasOwnProperty("hash"))
                if (typeof message.hash === "number")
                    object.hash = options.longs === String ? String(message.hash) : message.hash;
                else
                    object.hash = options.longs === String ? $util.Long.prototype.toString.call(message.hash) : options.longs === Number ? new $util.LongBits(message.hash.low >>> 0, message.hash.high >>> 0).toNumber() : message.hash;
            if (message.context && message.context.length) {
                object.context = [];
                for (var j = 0; j < message.context.length; ++j)
                    object.context[j] = message.context[j];
            }
            return object;
        };

        /**
         * Converts this Error to JSON.
         * @function toJSON
         * @memberof proto.Error
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Error.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return Error;
    })();

    proto.Vulnerability = (function() {

        /**
         * Properties of a Vulnerability.
         * @memberof proto
         * @interface IVulnerability
         * @property {number} [line] Vulnerability line
         * @property {string} [location] Vulnerability location
         * @property {proto.IError} [error] Vulnerability error
         * @property {proto.IDetection} [detection] Vulnerability detection
         * @property {proto.IInvocation} [invocation] Vulnerability invocation
         * @property {string} [type] Vulnerability type
         */

        /**
         * Constructs a new Vulnerability.
         * @memberof proto
         * @classdesc Represents a Vulnerability.
         * @constructor
         * @param {proto.IVulnerability=} [properties] Properties to set
         */
        function Vulnerability(properties) {
            if (properties)
                for (var keys = Object.keys(properties), i = 0; i < keys.length; ++i)
                    if (properties[keys[i]] != null)
                        this[keys[i]] = properties[keys[i]];
        }

        /**
         * Vulnerability line.
         * @member {number}line
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.line = 0;

        /**
         * Vulnerability location.
         * @member {string}location
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.location = "";

        /**
         * Vulnerability error.
         * @member {(proto.IError|null|undefined)}error
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.error = null;

        /**
         * Vulnerability detection.
         * @member {(proto.IDetection|null|undefined)}detection
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.detection = null;

        /**
         * Vulnerability invocation.
         * @member {(proto.IInvocation|null|undefined)}invocation
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.invocation = null;

        /**
         * Vulnerability type.
         * @member {string}type
         * @memberof proto.Vulnerability
         * @instance
         */
        Vulnerability.prototype.type = "";

        /**
         * Creates a new Vulnerability instance using the specified properties.
         * @function create
         * @memberof proto.Vulnerability
         * @static
         * @param {proto.IVulnerability=} [properties] Properties to set
         * @returns {proto.Vulnerability} Vulnerability instance
         */
        Vulnerability.create = function create(properties) {
            return new Vulnerability(properties);
        };

        /**
         * Encodes the specified Vulnerability message. Does not implicitly {@link proto.Vulnerability.verify|verify} messages.
         * @function encode
         * @memberof proto.Vulnerability
         * @static
         * @param {proto.IVulnerability} message Vulnerability message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Vulnerability.encode = function encode(message, writer) {
            if (!writer)
                writer = $Writer.create();
            if (message.line != null && message.hasOwnProperty("line"))
                writer.uint32(/* id 1, wireType 0 =*/8).int32(message.line);
            if (message.location != null && message.hasOwnProperty("location"))
                writer.uint32(/* id 2, wireType 2 =*/18).string(message.location);
            if (message.error != null && message.hasOwnProperty("error"))
                $root.proto.Error.encode(message.error, writer.uint32(/* id 3, wireType 2 =*/26).fork()).ldelim();
            if (message.detection != null && message.hasOwnProperty("detection"))
                $root.proto.Detection.encode(message.detection, writer.uint32(/* id 4, wireType 2 =*/34).fork()).ldelim();
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                $root.proto.Invocation.encode(message.invocation, writer.uint32(/* id 5, wireType 2 =*/42).fork()).ldelim();
            if (message.type != null && message.hasOwnProperty("type"))
                writer.uint32(/* id 6, wireType 2 =*/50).string(message.type);
            return writer;
        };

        /**
         * Encodes the specified Vulnerability message, length delimited. Does not implicitly {@link proto.Vulnerability.verify|verify} messages.
         * @function encodeDelimited
         * @memberof proto.Vulnerability
         * @static
         * @param {proto.IVulnerability} message Vulnerability message or plain object to encode
         * @param {$protobuf.Writer} [writer] Writer to encode to
         * @returns {$protobuf.Writer} Writer
         */
        Vulnerability.encodeDelimited = function encodeDelimited(message, writer) {
            return this.encode(message, writer).ldelim();
        };

        /**
         * Decodes a Vulnerability message from the specified reader or buffer.
         * @function decode
         * @memberof proto.Vulnerability
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @param {number} [length] Message length if known beforehand
         * @returns {proto.Vulnerability} Vulnerability
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Vulnerability.decode = function decode(reader, length) {
            if (!(reader instanceof $Reader))
                reader = $Reader.create(reader);
            var end = length === undefined ? reader.len : reader.pos + length, message = new $root.proto.Vulnerability();
            while (reader.pos < end) {
                var tag = reader.uint32();
                switch (tag >>> 3) {
                case 1:
                    message.line = reader.int32();
                    break;
                case 2:
                    message.location = reader.string();
                    break;
                case 3:
                    message.error = $root.proto.Error.decode(reader, reader.uint32());
                    break;
                case 4:
                    message.detection = $root.proto.Detection.decode(reader, reader.uint32());
                    break;
                case 5:
                    message.invocation = $root.proto.Invocation.decode(reader, reader.uint32());
                    break;
                case 6:
                    message.type = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
                }
            }
            return message;
        };

        /**
         * Decodes a Vulnerability message from the specified reader or buffer, length delimited.
         * @function decodeDelimited
         * @memberof proto.Vulnerability
         * @static
         * @param {$protobuf.Reader|Uint8Array} reader Reader or buffer to decode from
         * @returns {proto.Vulnerability} Vulnerability
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        Vulnerability.decodeDelimited = function decodeDelimited(reader) {
            if (!(reader instanceof $Reader))
                reader = new $Reader(reader);
            return this.decode(reader, reader.uint32());
        };

        /**
         * Verifies a Vulnerability message.
         * @function verify
         * @memberof proto.Vulnerability
         * @static
         * @param {Object.<string,*>} message Plain object to verify
         * @returns {string|null} `null` if valid, otherwise the reason why it is not
         */
        Vulnerability.verify = function verify(message) {
            if (typeof message !== "object" || message === null)
                return "object expected";
            if (message.line != null && message.hasOwnProperty("line"))
                if (!$util.isInteger(message.line))
                    return "line: integer expected";
            if (message.location != null && message.hasOwnProperty("location"))
                if (!$util.isString(message.location))
                    return "location: string expected";
            if (message.error != null && message.hasOwnProperty("error")) {
                var error = $root.proto.Error.verify(message.error);
                if (error)
                    return "error." + error;
            }
            if (message.detection != null && message.hasOwnProperty("detection")) {
                error = $root.proto.Detection.verify(message.detection);
                if (error)
                    return "detection." + error;
            }
            if (message.invocation != null && message.hasOwnProperty("invocation")) {
                error = $root.proto.Invocation.verify(message.invocation);
                if (error)
                    return "invocation." + error;
            }
            if (message.type != null && message.hasOwnProperty("type"))
                if (!$util.isString(message.type))
                    return "type: string expected";
            return null;
        };

        /**
         * Creates a Vulnerability message from a plain object. Also converts values to their respective internal types.
         * @function fromObject
         * @memberof proto.Vulnerability
         * @static
         * @param {Object.<string,*>} object Plain object
         * @returns {proto.Vulnerability} Vulnerability
         */
        Vulnerability.fromObject = function fromObject(object) {
            if (object instanceof $root.proto.Vulnerability)
                return object;
            var message = new $root.proto.Vulnerability();
            if (object.line != null)
                message.line = object.line | 0;
            if (object.location != null)
                message.location = String(object.location);
            if (object.error != null) {
                if (typeof object.error !== "object")
                    throw TypeError(".proto.Vulnerability.error: object expected");
                message.error = $root.proto.Error.fromObject(object.error);
            }
            if (object.detection != null) {
                if (typeof object.detection !== "object")
                    throw TypeError(".proto.Vulnerability.detection: object expected");
                message.detection = $root.proto.Detection.fromObject(object.detection);
            }
            if (object.invocation != null) {
                if (typeof object.invocation !== "object")
                    throw TypeError(".proto.Vulnerability.invocation: object expected");
                message.invocation = $root.proto.Invocation.fromObject(object.invocation);
            }
            if (object.type != null)
                message.type = String(object.type);
            return message;
        };

        /**
         * Creates a plain object from a Vulnerability message. Also converts values to other types if specified.
         * @function toObject
         * @memberof proto.Vulnerability
         * @static
         * @param {proto.Vulnerability} message Vulnerability
         * @param {$protobuf.IConversionOptions} [options] Conversion options
         * @returns {Object.<string,*>} Plain object
         */
        Vulnerability.toObject = function toObject(message, options) {
            if (!options)
                options = {};
            var object = {};
            if (options.defaults) {
                object.line = 0;
                object.location = "";
                object.error = null;
                object.detection = null;
                object.invocation = null;
                object.type = "";
            }
            if (message.line != null && message.hasOwnProperty("line"))
                object.line = message.line;
            if (message.location != null && message.hasOwnProperty("location"))
                object.location = message.location;
            if (message.error != null && message.hasOwnProperty("error"))
                object.error = $root.proto.Error.toObject(message.error, options);
            if (message.detection != null && message.hasOwnProperty("detection"))
                object.detection = $root.proto.Detection.toObject(message.detection, options);
            if (message.invocation != null && message.hasOwnProperty("invocation"))
                object.invocation = $root.proto.Invocation.toObject(message.invocation, options);
            if (message.type != null && message.hasOwnProperty("type"))
                object.type = message.type;
            return object;
        };

        /**
         * Converts this Vulnerability to JSON.
         * @function toJSON
         * @memberof proto.Vulnerability
         * @instance
         * @returns {Object.<string,*>} JSON object
         */
        Vulnerability.prototype.toJSON = function toJSON() {
            return this.constructor.toObject(this, $protobuf.util.toJSONOptions);
        };

        return Vulnerability;
    })();

    return proto;
})();

module.exports = $root;
