// TODO: remove unused fields

/**
 * BitSensor Config
 * @class Config
 */
class Config {
  /**
   * Creates an instance of Config.
   * @param {any} config 
   * @memberof Config
   */
  constructor(config) {
    if (!config) {
      throw Error('Configuration not found.');
    }

    this.uri = config[Config.URI] || null;
    this.username = config[Config.USER] || null;
    this.apiKey = config[Config.API_KEY] || null;
    this.mode = config[Config.MODE] || Config.MODE_ON;
    this.connectionFail = config[Config.CONNECTION_FAIL] || Config.ACTION_BLOCK;
    this.ipAddressSrc = config[Config.IP_ADDRESS_SRC] || Config.IP_ADDRESS_REMOTE_ADDR;
    this.ipAddress = config[Config.IP_ADDRESS] || null;
    this.nodeApi = config[Config.NODE_API] || Config.NODE_API_HTTP;
    this.applicationName = config[Config.APPLICATION_NAME] || null;
  }
}

// Config properties

Config.URI = 'uri';
Config.USER = 'username';
Config.API_KEY = 'apiKey';
Config.MODE = 'mode';
Config.MODE_DETECTION = 'detection';
Config.MODE_ON = 'on';
Config.CONNECTION_FAIL = 'connectionFail';
Config.ACTION_ALLOW = 'allow';
Config.ACTION_BLOCK = 'block';
Config.IP_ADDRESS_SRC = 'ipAddressSrc';
Config.IP_ADDRESS = 'ipAddress';
Config.IP_ADDRESS_MANUAL = 'manual';
Config.IP_ADDRESS_REMOTE_ADDR = 'remoteAddr';
Config.IP_ADDRESS_X_FORWARDED_FOR = 'forwardedFor';
Config.NODE_API = 'nodeApi';
Config.NODE_API_HTTP = 'http';
Config.NODE_API_HAPI = 'hapi';
Config.APPLICATION_NAME = 'application.name';
Config.NAME = 'name';

module.exports = Config;
