module.exports = {
  Context: {
    IP: 'ip',
    PROTOCOL_VERSION: 'http.version',
    QUERY_STRING: 'http.query',
    HTTP_USER_AGENT: 'http.userAgent',
    HTTP_REFERER: 'http.referer',
    REQUEST_METHOD: 'http.type',
    HTTP_ACCEPT: 'http.acceptMedia',
    HTTP_ACCEPT_CHARSET: 'http.acceptCharset',
    HTTP_ACCEPT_ENCODING: 'http.acceptEncoding',
    HTTP_ACCEPT_LANGUAGE: 'http.acceptLanguage',
    PATH_INFO: 'http.pathInfo',
    HTTPS: 'http.https',
    X_FORWARDED_FOR: 'http.x_forwarded_for',
  },
  Endpoint: {
    ADDRESS: 'address',
    NAME: 'name',
    SOFTWARE: 'software',
    PORT: 'port',
    APPLICATION: 'application',
    START_DATE: 'startDate',
    DOCUMENT_ROOT: 'documentRoot', // ?
    INTERFACE: 'interface', // ?
    LOCATION: 'location', // ?
    LOCALTIME: 'localtime',
    URI: 'uri',
    STATUS: 'http.code',
  },
  Meta: {
    ENCRYPTION: 'encryption',
    ENCRYPTION_KEY: 'key',
    DATA: 'data', // ?
    USER: 'user',
    API_KEY: 'apiKey',
    PROVIDER: 'provider',
    VERSION: 'version',
  },
  Environment: {
    OS_NAME: 'os.name',
    OS_VERSION: 'os.version',
    OS_ARCH: 'os.arch',
    JS_VERSION: 'node-js.version',
    JS_VENDOR: 'node-js.vendor',
    HOST_NAME: 'host.name',
    MEMORY_SIZE: 'memory.size',
    MEMORY_USED: 'memory.used',
  },
};
