const os = require('os');
const { Environment } = require('../constants');
const Handler = require('../../handler/handler');
/**
 * Environment handler for datapoints
 * @class EnvironmentHandler
 * @extends {Handler}
 */
class EnvironmentHandler extends Handler {
  /**
   * Handles the datapoint
   * @param {any} datapoint 
   * @memberof EnvironmentHandler
   */
  handle(datapoint) {
    datapoint.endpoint[Environment.OS_NAME] = os.type();
    datapoint.endpoint[Environment.OS_VERSION] = os.release();
    datapoint.endpoint[Environment.OS_ARCH] = os.arch();
    datapoint.endpoint[Environment.JS_VERSION] = process.version;
    datapoint.endpoint[Environment.JS_VENDOR] = 'node-js';
    datapoint.endpoint[Environment.HOST_NAME] = os.hostname();
    datapoint.endpoint[Environment.MEMORY_SIZE] = os.totalmem();
    datapoint.endpoint[Environment.MEMORY_USED] = process.memoryUsage().heapTotal;
  }
}

module.exports = EnvironmentHandler;
