const { Datapoint } = require('./../index');
const { expect } = require('chai');
const cls = require('continuation-local-storage');

describe('Continuation', () => {
  const session = cls.createNamespace('session');
  session.run(() => {
    const datapoint = new Datapoint();
    session.set('datapoint', datapoint);
    const sessionDatapoint = session.get('datapoint');
    it('should not be empty', () => {
      expect(sessionDatapoint).to.equal(datapoint);
    });
  });

  const datapoint = session.get('datapoint');
  it('should be empty', () => {
    expect(datapoint).to.be.undefined;
  });
});
