const { expect } = require('chai');
const { Datapoint, Error, GeneratedBy } = require('./../core/compiled').proto;

describe('Datapoint', () => {
  let datapoint;
  beforeEach(() => {
    datapoint = new Datapoint();
  });

  describe('#addError', () => {
    it('must add error', () => {
      const error = new Error();
      error.code = 1;
      error.description = 'test';
      error.location = 'main.js';
      error.line = 2;
      error.generatedby = GeneratedBy.PLUGIN;

      datapoint.errors.push(error);
      expect(datapoint.errors).to.include(error);
    });
  });
});
